SystemOrganization addCategory: #Tp1_Abejas!
SystemOrganization addCategory: #'Tp1_Abejas-Tests'!

Object subclass: #Abeja
	instanceVariableNames: 'aguijon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon
	^ aguijon! !

!Abeja methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:30'!
aguijon: anObject
	aguijon := anObject! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:48'!
comer: unaCantidad deNectarDe: unaColmena
^(unaCantidad <= unaColmena nectar)
	ifTrue: [unaColmena disminuirNectarEn: unaCantidad]
	ifFalse: [ Error signal: 'No se puede dar de comer a mas abejas ya que no alcanza la cantidad de nectar en la colmena' ].
! !

!Abeja methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 17:22'!
puedePicar
^self aguijon.
! !

Abeja subclass: #Obrera
	instanceVariableNames: 'rol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Obrera class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:55'!
crearConRol: unRol
|nuevaObrera|
nuevaObrera := self new.
nuevaObrera rol: unRol.
^ nuevaObrera.! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 01:09'!
initialize
self aguijon: true.! !

!Obrera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:49'!
realizarTarea:unaColmena
self rol realizarTarea: unaColmena.! !

!Obrera methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:07'!
rol
	^ rol! !

!Obrera methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:07'!
rol: anObject
	rol := anObject! !

Abeja subclass: #Reina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

Reina class
	instanceVariableNames: 'cantidadParaReproducirZanganos cantidadParaReproducir'!

Reina class
	instanceVariableNames: 'cantidadParaReproducirZanganos cantidadParaReproducir'!

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:33'!
initialize
self aguijon: false.! !

!Reina methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:26'!
realizarTarea: unaColmena 
|cantidadParaReproducir cantidadParaReproducirZanganos cantidadParaReproducirObreras|

cantidadParaReproducir := ((unaColmena nectar) * 0.3) asInteger.
cantidadParaReproducirZanganos := (cantidadParaReproducir * 0.2) asInteger.
cantidadParaReproducirObreras := (cantidadParaReproducir * 0.8) asInteger.

cantidadParaReproducirZanganos timesRepeat: [ unaColmena agregarAbeja: Zangano new ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ unaColmena agregarAbeja: ((Obrera new) rol: Pecoreadora new) ].
(cantidadParaReproducirObreras // 2) timesRepeat: [ unaColmena agregarAbeja: ((Obrera new) rol: Guardiana new)] .! !

Abeja subclass: #Zangano
	instanceVariableNames: 'corrienteDeAire'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Zangano class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:57'!
crearConCorrienteDeAire: unaCorriente
|nuevoZangano|
nuevoZangano := self new.
nuevoZangano corrienteDeAire: unaCorriente.
^ nuevoZangano.! !

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire
	^ corrienteDeAire! !

!Zangano methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:45'!
corrienteDeAire: anObject
	corrienteDeAire := anObject! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 5/24/2013 11:34'!
initialize 
self aguijon: false.! !

!Zangano methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:53'!
realizarTarea: unaColmena
unaColmena reducirTemperaturaEn: self corrienteDeAire.
"deshidratar el nectar?"! !

Object subclass: #Apiario
	instanceVariableNames: 'colmenas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Apiario class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:00'!
crearConColmenas: unasColmenas
|nuevoApiario|
nuevoApiario := self new.
nuevoApiario colmenas addAll: unasColmenas.
^ nuevoApiario.! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 21:08'!
colmenaMasFuerte
^ (self colmenas asSortedCollection: [:unaColmena :otraColmena | unaColmena cuantasPican >= otraColmena cuantasPican]) first.! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas
	^ colmenas! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
colmenas: anObject
	colmenas := anObject! !

!Apiario methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 12:58'!
initialize
colmenas := Bag new.! !

Object subclass: #Colmena
	instanceVariableNames: 'abejas floresCercanas nectar piquera temperatura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Colmena class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:08'!
crearConAbejas: unasAbejas conFlores: floresCercanas conNectar: nectar conPiquera: piquera conTemp: temperatura
|nuevaColmena|
nuevaColmena := self new.
nuevaColmena abejas addAll: unasAbejas.
nuevaColmena floresCercanas addAll: floresCercanas.
nuevaColmena nectar: nectar.
nuevaColmena piquera: piquera.
nuevaColmena temperatura: temperatura.
^ nuevaColmena.
! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas
	^ abejas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:38'!
abejas: anObject
	abejas := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:12'!
agregarAbeja: unaAbeja
self abejas add: unaAbeja.! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:17'!
alcanzaNectar: unaCantidad
^(unaCantidad <= self nectar)


	
! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:03'!
aumentarNectarEn: unaCantidad.
self nectar:  (self nectar + unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 20:36'!
comanNectar: unaCantidad
^[self abejas do: [:unaAbeja | unaAbeja comer: unaCantidad deNectarDe: self]] on: Error do: [:e | e messageText].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 01:20'!
cuantasPican
^self abejas count: [:unaAbeja | unaAbeja puedePicar].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:57'!
disminuirNectarEn: unaCantidad.
self nectar:  (self nectar - unaCantidad).! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/5/2013 23:58'!
elegirFlor
"la primera que tenga nectar"
^(self floresCercanas asOrderedCollection) first.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas
	^ floresCercanas! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 17:55'!
floresCercanas: anObject
	floresCercanas := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:09'!
initialize
abejas := Bag new.
floresCercanas := Bag new.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar
	^ nectar! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:02'!
nectar: anObject
	nectar := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 17:00'!
perteneceAColmena: unaAbeja
^self abejas includes: unaAbeja.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera
	^ piquera! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:38'!
piquera: anObject
	piquera := anObject! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 10:52'!
realicenTarea
self abejas do: [ :unaAbeja | unaAbeja realizarTarea: self ].! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 5/23/2013 00:45'!
reducirTemperaturaEn: unaCantidad
self temperatura: (self temperatura - unaCantidad).
! !

!Colmena methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 11:45'!
sacarAbeja: unaAbeja
self abejas remove: unaAbeja.! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura
	^ temperatura! !

!Colmena methodsFor: 'accessing' stamp: 'Facundo 5/23/2013 00:43'!
temperatura: anObject
	temperatura := anObject! !

Object subclass: #Flor
	instanceVariableNames: 'nectar distanciaAColmena'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Flor class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:02'!
crearConNectar: unaCantidad
|nuevaFlor|
nuevaFlor := self new.
nuevaFlor nectar: unaCantidad.
^ nuevaFlor.! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:23'!
disminuirNectarEn: unaCantidad
self nectar: (self nectar - unaCantidad).! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar
	^ nectar! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:14'!
nectar: anObject
	nectar := anObject! !

!Flor methodsFor: 'accessing' stamp: 'Facundo 5/21/2013 18:45'!
quitarNectar
^(self nectar > 3)
	ifTrue: [ 3 ]
	ifFalse: [ self nectar].! !

Object subclass: #Guardiana
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:59'!
buscarIntrusasEn: unaColmena
^ unaColmena piquera abejas select: [ :unaAbejaDePiquera | (self esIntrusa: unaAbejaDePiquera De: unaColmena) not].
"unaColmena piquera abejas detect: [ :unaAbejaDePiquera | (unaColmena abejas includes: unaAbejaDePiquera) not]."
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:52'!
damePiqueraDe: unaColmena
^ unaColmena piquera.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:56'!
esIntrusa: unaAbeja De: unaColmena
^ unaColmena abejas includes: unaAbeja.! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:20'!
picar: unaAbeja
self colmena piquera sacarAbeja: unaAbeja.
self colmena piquera sacarAbeja: self.
unaAbeja morir.
self morir.
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:44'!
picar: unaAbeja de: unaColmena
unaColmena piquera sacarAbeja: unaAbeja.
unaColmena piquera sacarAbeja: self.
unaColmena sacarAbeja: self.
! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:40'!
picarSiHayIntrusa: unaColmena
|unasAbejas|
unasAbejas := unaColmena piquera abejas select: [ :unaAbejaDePiquera | (unaColmena abejas includes: unaAbejaDePiquera) not].
(unasAbejas size> 0)
	ifTrue: [self picar: (unasAbejas asOrderedCollection) first de: unaColmena].! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:51'!
picarSiHayIntrusa: unasAbejas De: unaColmena
(unasAbejas size> 0)
	ifTrue: [self picar: (unasAbejas asOrderedCollection) first de: unaColmena].! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 13:45'!
realizarTarea
self picarSiHayIntrusa: (self buscarIntrusasEn: self piqueraQueVigila).

"piquera abejas select: [ :unaAbeja | (unaAbeja colmena == self colmena) not ]"! !

!Guardiana methodsFor: 'accessing' stamp: 'Facundo 6/6/2013 11:52'!
realizarTarea: unaColmena
self picarSiHayIntrusa: (self buscarIntrusasEn: unaColmena) De: unaColmena.! !

Object subclass: #Pecoreadora
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:22'!
nectarRecolectadoDe: unaFlor
^ unaFlor quitarNectar.

! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 6/5/2013 23:09'!
realizarTarea: unaColmena
self recolectarDe: unaColmena elegirFlor yDepositarEn: unaColmena.! !

!Pecoreadora methodsFor: 'as yet unclassified' stamp: 'Facundo 5/21/2013 18:22'!
recolectarDe: unaFlor yDepositarEn: unaColmena
unaColmena aumentarNectarEn: (self nectarRecolectadoDe: unaFlor).
unaFlor disminuirNectarEn: (self nectarRecolectadoDe: unaFlor).! !

Object subclass: #Piquera
	instanceVariableNames: 'centimetros abejas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas'!

!Piquera class methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:03'!
crearConCentimetros: unaCantidad yAbejas: unasAbejas
|nuevaPiquera|
nuevaPiquera := self new.
nuevaPiquera centimetros: unaCantidad.
nuevaPiquera abejas addAll: unasAbejas.
^ nuevaPiquera.! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas
	^ abejas! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:36'!
abejas: anObject
	abejas := anObject! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:20'!
buscarGuardianaEnPiquera: unaColmena.
^ (unaColmena piquera abejas select: [ : unaAbeja | unaAbeja isMemberOf: Guardiana ] ) first.! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros
	^ centimetros! !

!Piquera methodsFor: 'accessing' stamp: 'Facundo 5/22/2013 12:24'!
centimetros: anObject
	centimetros := anObject! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 13:05'!
initialize
abejas := Bag new.! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/4/2013 02:19'!
intentaPasar: unaAbeja
|guardiana|
guardiana := Guardiana new.
guardiana initialize.
guardiana colmena: self colmena.
self abejas add: guardiana.
"((self abejas select:[:unaA | unaA == guardiana]) asOrderedCollection first) picarSiHayIntrusa: {unaAbeja}."
self colmena abejas add: guardiana. "self colmena agregarAbeja: guardiana."
guardiana picarSiHayIntrusa: {unaAbeja}
! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 6/6/2013 12:23'!
intentaPasar: unaAbeja A: unaColmena
|guardiana|
guardiana := self buscarGuardianaEnPiquera: unaColmena.
((guardiana esIntrusa: unaAbeja De: unaColmena) not)
	ifTrue: [guardiana picar: unaAbeja de: unaColmena.].

! !

!Piquera methodsFor: 'as yet unclassified' stamp: 'Facundo 5/22/2013 13:19'!
sacarAbeja: unaAbeja 
self abejas remove: unaAbeja.! !

TestCase subclass: #ReinaTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tp1_Abejas-Tests'!

!ReinaTest commentStamp: '<historical>' prior: 0!
A ReinaTest is a test class for testing the behavior of Reina!

!ReinaTest methodsFor: 'tests-as yet unclassified' stamp: 'Facundo 6/6/2013 10:54'!
testRealizarTarea! !
